<?php

/*************************************************************************
 * Conversation Category - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\ConversationCategory;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
    {
        $this->schemaManager()->createTable('xc_conversation_category', function (Create $table)
        {
            $table->addColumn('conversation_category_id', 'int')->autoIncrement();$table->addColumn('title', 'varchar', 100);
            $table->addColumn('description', 'text');
            $table->addColumn('user_id', 'int');
            $table->addColumn('username', 'varchar', 100)->setDefault('');
            $table->addColumn('display_order', 'int')->setDefault(0);
            $table->addColumn('conversation_count', 'int')->setDefault(0);
            $table->addColumn('last_update', 'int')->setDefault(0);
            $table->addColumn('last_conversation_title', 'varchar', 100)->setDefault('');
            $table->addColumn('last_conversation_id', 'int')->setDefault(0);
        });
    }

    public function installStep2()
    {
        $this->db()->query("
			REPLACE INTO `xc_conversation_category`
				(`conversation_category_id`, 
				`title`, 
				`user_id`, `username`,
				`description`, `display_order`, 
				`conversation_count`, `last_update`, `last_conversation_title`, `last_conversation_id`)
			VALUES
				(1, 
				'كل المحادثات', 
				0, '',
				'هذا مثال على مدير التصنيفات، التي تحتوي على جميع محادثاتك', 1, 
				0, 0, '', 0);
		");
    }

    public function installStep3()
    {
        $this->schemaManager()->alterTable('xf_conversation_user', function (Alter $table)
        {
            $table->addColumn('conversation_category_id', 'int')->setDefault(0);
        });
    }

    public function uninstallStep1()
    {
        $this->schemaManager()->dropTable('xc_conversation_category');
    }

    public function uninstallStep2()
    {
        $this->schemaManager()->alterTable('xf_conversation_user', function (Alter $table)
        {
            $table->dropColumns('conversation_category_id');
        });
    }
}